<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\Request;
use Redirect;
use Session;

class Censure
{

    private $correct = false;
    private $requestTemp = '';

    private function mb_str_replace($search, $replace, $string)
    {
        $charset = mb_detect_encoding($string);

        $unicodeString = iconv($charset, "UTF-8", $string);

        return str_replace($search, $replace, $unicodeString);
    }

    private function textControl($content) {
        $mats = array_unique([
            'бздюха','бикса','блежник','блудилище','бляд','блябу','блябуду','блядун','блядунья','блядь','блядюга',
            'взьебка','волосянка','взьебывать','вз\'ебывать','выблядок','выблядыш','выебать','выеть','выпердеть',
            'высраться','выссаться','говенка','говенный','говешка','говназия','говнецо','говно','говноед','говночист',
            'говнюк','говнюха','говнядина','говняк','говняный','говнять','гондон','дермо','долбоеб','дрисня','дрист',
            'дристать','дристануть','дристун','дристуха','дрочена','дрочила','дрочилка','дрочить','дрочка','ебало',
            'ебал', 'пидар', 'архипиздрит','басран','бздение','бздеть','бздех','бзднуть','бздун','бздунья',
            'ебальник','ебануть','ебаный','ебарь','ебатория','ебать','ебаться','ебец','ебливый','ебля','ебнуть',
            'ебнуться','ебня','ебун','елда','елдак','елдачить','заговнять','задристать','задрока','заеба','заебанец',
            'заебать','заебаться','заебываться','заеть','залупа','залупаться','залупить','залупиться','замудохаться',
            'засерун','засеря','засерать','засирать','засранец','засрун','захуячить','злоебучий','изговнять','изговняться',
            'ибат', 'мудил', 'пидор', 'ёб', 'иблан', 'ебла', 'писец', 'ебат', 'бля', 'выеб', 'ебан',
            'кляпыжиться','курва','курвенок','курвин','курвяжник','курвяжница','курвяжный','манда','мандавошка','мандей',
            'мандеть','мандища','мандюк','минет','минетчик','минетчица','мокрохвостка','мокрощелка','мудак','муде',
            'мудеть','мудила','мудистый','мудня','мудоеб','мудозвон','муйня','набздеть','наговнять','надристать','надрочить',
            'наебать','наебнуться','наебывать','нассать','нахезать','нахуйник','насцать','обдристаться','обдристаться',
            'невъеб', 'заеби', 'заебо', 'заеба', 'ебть', 'епты', 'епта', 'ёпты', 'ёпта', 'жопа', 'жопу', 'жопы',
            'обосранец','обосрать','обосцать','обосцаться','обсирать','опизде','отпиздячить','отпороть','отъеть',
            'отъеб', 'уебо', 'уёбо', 'уёба', 'уеба', 'уебу', 'въеб', 'ебнут', 'ебан', 'ебат',
            'охуевательский','охуевать','охуевающий','охуеть','охуительный','охуячивать','охуячить','педрик','пердеж',
            'пердение','пердеть','пердильник','перднуть','пердун','пердунец','пердунина','пердунья','пердуха','пердь',
            'передок','пернуть','пидор','пизда','пиздануть','пизденка','пиздеть','пиздить','пиздища','пиздобратия',
            'пиздец', 'сука', 'педик', 'пидр', 'пидер', 'насрала', 'пизде', 'членос', 'соска', 'охуев',
            'пиздоватый','пиздорванец','пиздорванка','пиздострадатель','пиздун','пиздюга','пиздюк','пиздячить','писять',
            'питишка','плеха','подговнять','подъебнуться','поебать','поеть','попысать','посрать','поставить','поцоватый',
            'презерватив','проблядь','проебать','промандеть','промудеть','пропиздеть','пропиздячить','пысать','разъеба',
            'разъебай','распиздай','распиздеться','распиздяй','распроеть','растыка','сговнять','секель','серун','серька',
            'сика','сикать','сикель','сирать','сирывать','скурвиться','скуреха','скурея','скуряга','скуряжничать',
            'спиздить','срака','сраный','сранье','срать','срун','ссака','ссаки','ссать','старпер','струк','суходрочка',
            'сцавинье','сцака','сцаки','сцание','сцать','сциха','сцуль','сцыха','сыкун','титечка','титечный','титка',
            'титочка','титька','трипер','триппер','уеть','усраться','усцаться','фик','фуй','хезать','хер','херня','херовина',
            'херовый','хитрожопый','хлюха','хуевина','хуевый','хуек','хуепромышленник','хуерик','хуесос','хуище','хуй',
            'хуев', 'педера', 'охуен', 'срану', 'сраны', 'срана', 'хуё', 'хуя', 'хуе', 'хуи', 'хую', 'опездол',
            'хуйня','хуйрик','хуякать','хуякнуть','целка','шлюха',
            'жопа', 'говно', 'мудач', 'пиздо', 'хуюш', 'хуяс', 'ебаш', 'сцуко', 'сцука', 'хует', 'ёба'
        ]);

        $isk_mats = [
            'страхуй', 'стебать', 'присоска'
        ];

        $maska = '';

        $lowContent = mb_strtolower($content);
        foreach ($mats as $mat) {
            if (strpos($lowContent, $mat) !== false) {
//                dd($mat);
//                $lowContent = str_replace($mat, str_repeat('*', mb_strlen($mat)), $lowContent);

//
                $lowContent = preg_replace_callback("~$mat~miu", function($matches) use ($mat) {
//                    dd('.....................'.$matches[0]);
                    return preg_replace('/'.$mat.'/miu', str_repeat('*', mb_strlen($mat)), $matches[0]);
                }, $content);

                $maska .= $mat . ', ';
            }

            $content = $lowContent;

//            dd($content);
            foreach ($isk_mats as $isk_mat) {
                if (strpos(strtolower($isk_mat), $mat)) {
                    if (strpos(strtolower($content), $isk_mat) !== false) {
                        $maska = NULL;
                    }
                }
            }
//            dd($content);
        }

//        dd($content);

        if ($maska) {
            Session::put('error', 'У нас не ругаются!  ' . $maska);
            $this->requestTemp = $content;


            $this->correct = false;
        } else {
            $this->correct = true;
        }
    }

    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {

        if ($request->input('message')) {
            $field = 'message';
            $this->textControl($request->input($field), $field);
            $request->merge([
                $field => $this->requestTemp
            ]);
        } else {
            $this->correct = true;
        }

        if($this->correct)
            return $next($request);
        else
            return Redirect::back();//->withErrors(['msg', 'The Message']);//redirect()->back()->with('error', 'НЕЛЬЗЯ МАТЕРИТЬСЯ!!! <br>' . $maska);
    }
}
